import * as React from 'react';
export declare type IMaskProps<T extends object> = {
    [K in keyof T]?: T[K];
};
export declare type IRulesProps<T extends object> = {
    [K in keyof T]: (value1: T[K], value2: T[K], name: string) => boolean;
};
export declare type IMaskChildren<T> = {
    flags?: Partial<T>;
};
declare function createMaskedProvider<Flags extends object>(initial: Flags, rules?: Partial<IRulesProps<Flags>>): {
    Provider: React.StatelessComponent<{
        value: Partial<Flags>;
        rules?: Partial<IRulesProps<Flags>>;
    }>;
    Switch: React.StatelessComponent<{
        flags: Partial<Flags>;
        children: (React.StatelessComponent<{}> | React.StatelessComponent<IMaskProps<Flags> & IMaskChildren<Flags>>)[];
    }>;
    Case: React.StatelessComponent<IMaskProps<Flags> & IMaskChildren<Flags>>;
    Default: React.StatelessComponent<{}>;
};
export default createMaskedProvider;
