"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var defaultComparator = function (a, b) { return a === b; };
var match = function (flags, mask) { return (Object
    .keys(mask)
    .every(function (key) { return (flags.rules[key] || defaultComparator)(mask[key], flags.value[key], key); })); };
function find(array, predicate) {
    return array.find(predicate);
}
var merge = function (a, key, c) { return (__assign({}, (a[key]), c)); };
var getProps = function (_a) {
    var flags = _a.flags, children = _a.children, mask = __rest(_a, ["flags", "children"]);
    return mask;
};
function createMaskedProvider(initial, rules) {
    if (rules === void 0) { rules = {}; }
    var context = React.createContext({
        value: initial,
        rules: rules
    });
    var Consumer = context.Consumer;
    var empty = {
        value: {},
        rules: {}
    };
    var Provider = function (_a) {
        var value = _a.value, _b = _a.rules, rules = _b === void 0 ? {} : _b, children = _a.children;
        return (React.createElement(Consumer, null, function (flags) {
            if (flags === void 0) { flags = empty; }
            return React.createElement(context.Provider, { value: {
                    value: merge(flags, 'value', value),
                    rules: merge(flags, 'rules', rules),
                } }, children);
        }));
    };
    var Case = function (props) {
        var flags = props.flags, children = props.children;
        var mask = getProps(props);
        if (flags) {
            return (match({ value: flags, rules: {} }, mask) ? children : null);
        }
        return (React.createElement(Consumer, null, function (flags) { return match(flags, mask) ? children : null; }));
    };
    var Default = function (_a) {
        var children = _a.children;
        return children;
    };
    var CaseType = (React.createElement(Case, null)).type;
    var DefaultType = (React.createElement(Default, null)).type;
    var pickCase = function (mask, children) { return (find(children, function (child) { return typeof child === 'object' && CaseType === child.type && match(mask, getProps(child.props)); }) ||
        find(children, function (child) { return typeof child === 'object' && DefaultType === child.type; }) ||
        null); };
    var Switch = function (_a) {
        var children = _a.children, flags = _a.flags;
        return (flags
            ? pickCase({ values: flags }, React.Children.toArray(children))
            : (React.createElement(Consumer, null, function (mask) { return pickCase(mask, React.Children.toArray(children)); })));
    };
    return {
        Provider: Provider,
        Switch: Switch,
        Case: Case,
        Default: Default
    };
}
exports.default = createMaskedProvider;
