"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
;
var deffered = function () {
    var d = {};
    d.p = new Promise(function (resolve, reject) {
        d.resolve = resolve;
        d.reject = reject;
    });
    return d;
};
var Promised = (function (_super) {
    __extends(Promised, _super);
    function Promised() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            active: false,
            executed: false
        };
        _this.promise = deffered();
        _this.callback = function () {
            _this.setState({
                active: true
            });
            if (_this.props.autoexecuted) {
                _this.fulfill(null);
            }
            return _this.promise.p;
        };
        _this.forwardRef = function (ref) {
            _this.ref = ref;
            _this.componentDidUpdate();
        };
        _this.fulfill = function (a) {
            if (_this.state.active) {
                _this.setState({
                    executed: true,
                    active: false,
                });
                _this.promise.resolve(a);
            }
            else if (_this.state.executed) {
                console.error('react-queue: trying to finish finished Promised');
                return false;
            }
            else {
                console.error('react-queue: trying to finish unstarted Promised');
                return false;
            }
            return true;
        };
        return _this;
    }
    Promised.prototype.componentDidMount = function () {
        var _a = this.props, channel = _a.channel, priority = _a.priority, disabled = _a.disabled;
        this.q = channel.add(this.callback, disabled ? Infinity : (priority || 0), this.ref);
    };
    Promised.prototype.componentWillUnmount = function () {
        var channel = this.props.channel;
        channel.remove(this.q);
    };
    Promised.prototype.componentDidUpdate = function () {
        var _a = this.props, channel = _a.channel, priority = _a.priority, disabled = _a.disabled;
        channel.replace(this.q, this.callback, disabled ? Infinity : (priority || 0), this.ref);
    };
    Promised.prototype.render = function () {
        var _a = this.state, active = _a.active, executed = _a.executed;
        return this.props.children({
            active: active,
            executed: executed,
            fired: active || executed,
            done: this.fulfill,
            forwardRef: this.forwardRef
        }) || null;
    };
    return Promised;
}(React.Component));
exports.Promised = Promised;
